<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑药品库' : '添加药品库'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="药名" name="name">
        <a-input
          allow-clear
          placeholder="请输入药名"
          v-model:value="form.name"
        />
      </a-form-item>
      <a-form-item label="拼音" name="pinyin">
        <a-input
          allow-clear
          placeholder="请输入拼音"
          v-model:value="form.pinyin"
        />
      </a-form-item>
      <a-form-item label="分类" name="category">
        <a-input
          allow-clear
          placeholder="请输入分类"
          v-model:value="form.category"
        />
      </a-form-item>
      <a-form-item label="规格" name="specification">
        <a-input
          allow-clear
          placeholder="请输入规格"
          v-model:value="form.specification"
        />
      </a-form-item>
      <a-form-item label="单位" name="unit">
        <a-input
          allow-clear
          placeholder="请输入单位（如“克”、“袋”）"
          v-model:value="form.unit"
        />
      </a-form-item>
      <a-form-item label="描述" name="content">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.content"
        />
      </a-form-item>
      <a-form-item label="单价" name="pricePerUnit">
        <a-input
          allow-clear
          placeholder="请输入单价"
          v-model:value="form.pricePerUnit"
        />
      </a-form-item>
      <a-form-item label="是否活跃" name="isActive">
        <a-input
          allow-clear
          placeholder="请输入是否活跃"
          v-model:value="form.isActive"
        />
      </a-form-item>
      <a-form-item label="备注" name="comments">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.comments"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject } from 'ele-admin-pro';
  import { addClinicMedicine, updateClinicMedicine } from '@/api/clinic/clinicMedicine';
  import { ClinicMedicine } from '@/api/clinic/clinicMedicine/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ClinicMedicine | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ClinicMedicine>({
    id: undefined,
    name: undefined,
    pinyin: undefined,
    category: undefined,
    specification: undefined,
    unit: undefined,
    content: undefined,
    pricePerUnit: undefined,
    isActive: undefined,
    userId: undefined,
    comments: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    clinicMedicineName: [
      {
        required: true,
        type: 'string',
        message: '请填写药品库名称',
        trigger: 'blur'
      }
    ]
  });

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateClinicMedicine : addClinicMedicine;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
